SFML 2.3.2

- Main Page
- Related Pages
- Modules
- Classes
- Files

- Class List
- Class Index
- Class Hierarchy
- Class Members

Public Member Functions | List of all members
sf::SocketSelector Class Reference
Network module

Multiplexer that allows to read from multiple sockets. More...

`#include <SocketSelector.hpp>`

## Public Member Functions

| SocketSelector ()
| Default constructor. More...
| SocketSelector (const SocketSelector &copy)
| Copy constructor. More...
| ~SocketSelector ()
| Destructor. More...
void | add (Socket &socket)
| Add a new socket to the selector. More...
void | remove (Socket &socket)
| Remove a socket from the selector. More...
void | clear ()
| Remove all the sockets stored in the selector. More...
bool | wait (Time timeout=Time::Zero)
| Wait until one or more sockets are ready to receive. More...
bool | isReady (Socket &socket) const
| Test a socket to know if it is ready to receive data. More...
SocketSelector & | operator= (const SocketSelector &right)
| Overload of assignment operator. More...

## Detailed Description

Multiplexer that allows to read from multiple sockets.

Socket selectors provide a way to wait until some data is available on a set of sockets, instead of just one.

This is convenient when you have multiple sockets that may possibly receive data, but you don't know which one will be ready first. In particular, it avoids to use a thread for each socket; with selectors, a single thread can handle all the sockets.

All types of sockets can be used in a selector:

- sf::TcpListener
- sf::TcpSocket
- sf::UdpSocket

A selector doesn't store its own copies of the sockets (socket classes are not copyable anyway), it simply keeps a reference to the original sockets that you pass to the "add" function. Therefore, you can't use the selector as a socket container, you must store them outside and make sure that they are alive as long as they are used in the selector.

Using a selector is simple:

- populate the selector with all the sockets that you want to observe
- make it wait until there is data available on any of the sockets
- test each socket to find out which ones are ready

Usage example:

// Create a socket to listen to new connections
sf::TcpListener listener;
listener.listen(55001);
// Create a list to store the future clients
std::list<sf::TcpSocket*> clients;
// Create a selector
sf::SocketSelector selector;
// Add the listener to the selector
selector.add(listener);
// Endless loop that waits for new connections
while (running)
{
// Make the selector wait for data on any socket
if (selector.wait())
{
// Test the listener
if (selector.isReady(listener))
{
// The listener is ready: there is a pending connection
sf::TcpSocket* client = new sf::TcpSocket;
if (listener.accept(*client) == sf::Socket::Done)
{
// Add the new client to the clients list
clients.push_back(client);
// Add the new client to the selector so that we will
// be notified when he sends something
selector.add(*client);
}
else
{
// Error, we won't get a new connection, delete the socket
delete client;
}
}
else
{
// The listener socket is not ready, test all other sockets (the clients)
for (std::list<sf::TcpSocket*>::iterator it = clients.begin(); it != clients.end(); ++it)
{
sf::TcpSocket& client = **it;
if (selector.isReady(client))
{
// The client has sent some data, we can receive it
sf::Packet packet;
if (client.receive(packet) == sf::Socket::Done)
{
...
}
}
}
}
}
}

See also
  sf::Socket

Definition at line 43 of file SocketSelector.hpp.

## Constructor & Destructor Documentation

sf::SocketSelector::SocketSelector | ( |  | ) |

Default constructor.

sf::SocketSelector::SocketSelector | ( | const SocketSelector & | copy | ) |

Copy constructor.

Parameters

  copy | Instance to copy

sf::SocketSelector::~SocketSelector | ( |  | ) |

Destructor.

## Member Function Documentation

void sf::SocketSelector::add | ( | Socket & | socket | ) |

Add a new socket to the selector.

This function keeps a weak reference to the socket, so you have to make sure that the socket is not destroyed while it is stored in the selector. This function does nothing if the socket is not valid.

Parameters

  socket | Reference to the socket to add

See also
  remove, clear

void sf::SocketSelector::clear | ( |  | ) |

Remove all the sockets stored in the selector.

This function doesn't destroy any instance, it simply removes all the references that the selector has to external sockets.

See also
  add, remove

bool sf::SocketSelector::isReady | ( | Socket & | socket | ) | const

Test a socket to know if it is ready to receive data.

This function must be used after a call to Wait, to know which sockets are ready to receive data. If a socket is ready, a call to receive will never block because we know that there is data available to read. Note that if this function returns true for a TcpListener, this means that it is ready to accept a new connection.

Parameters

  socket | Socket to test

Returns
  True if the socket is ready to read, false otherwise

See also
  isReady

SocketSelector& sf::SocketSelector::operator= | ( | const SocketSelector & | right | ) |

Overload of assignment operator.

Parameters

  right | Instance to assign

Returns
  Reference to self

void sf::SocketSelector::remove | ( | Socket & | socket | ) |

Remove a socket from the selector.

This function doesn't destroy the socket, it simply removes the reference that the selector has to it.

Parameters

  socket | Reference to the socket to remove

See also
  add, clear

bool sf::SocketSelector::wait | ( | Time | timeout = `Time::Zero` | ) |

Wait until one or more sockets are ready to receive.

This function returns as soon as at least one socket has some data available to be received. To know which sockets are ready, use the isReady function. If you use a timeout and no socket is ready before the timeout is over, the function returns false.

Parameters

  timeout | Maximum time to wait, (use Time::Zero for infinity)

Returns
  True if there are sockets ready, false otherwise

See also
  isReady

The documentation for this class was generated from the following file:

- SocketSelector.hpp